/**
 * Bundle of @devexpress/dx-react-grid-bootstrap3
 * Generated: 2017-05-26
 * Version: 1.0.0-alpha.1
 * License: https://js.devexpress.com/Licensing
 */

(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('@devexpress/dx-react-grid'), require('prop-types'), require('react-bootstrap'), require('@devexpress/dx-react-core')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react', '@devexpress/dx-react-grid', 'prop-types', 'react-bootstrap', '@devexpress/dx-react-core'], factory) :
	(factory((global.DevExpress = global.DevExpress || {}, global.DevExpress.DXReactGridBootstrap3 = global.DevExpress.DXReactGridBootstrap3 || {}),global.React,global.DevExpress.DXReactGrid,global.PropTypes,global.ReactBootstrap,global.DevExpress.DXReactCore));
}(this, (function (exports,React,_devexpress_dxReactGrid,PropTypes,reactBootstrap,_devexpress_dxReactCore) { 'use strict';

React = 'default' in React ? React['default'] : React;
PropTypes = 'default' in PropTypes ? PropTypes['default'] : PropTypes;

var PageSizeSelector = function PageSizeSelector(_ref) {
  var pageSize = _ref.pageSize,
      onPageSizeChange = _ref.onPageSizeChange,
      allowedPageSizes = _ref.allowedPageSizes;
  return React.createElement(
    'div',
    { style: { display: 'inline-block' } },
    React.createElement(
      'select',
      {
        className: 'form-control visible-xs-inline-block',
        style: { width: 'auto' },
        value: pageSize,
        onChange: function onChange(e) {
          return onPageSizeChange(parseInt(e.target.value, 10));
        }
      },
      allowedPageSizes.map(function (val) {
        return React.createElement(
          'option',
          { key: val, value: val },
          val
        );
      })
    ),
    React.createElement(
      'ul',
      {
        className: 'pagination hidden-xs',
        style: {
          margin: 0,
          verticalAlign: 'bottom'
        }
      },
      allowedPageSizes.map(function (item) {
        return React.createElement(
          'li',
          { key: item, className: item === pageSize ? 'active' : '' },
          React.createElement(
            'a',
            {
              href: '#',
              onClick: function onClick(e) {
                e.preventDefault();
                onPageSizeChange(item);
              }
            },
            item
          )
        );
      })
    )
  );
};

PageSizeSelector.propTypes = {
  pageSize: PropTypes.number.isRequired,
  onPageSizeChange: PropTypes.func.isRequired,
  allowedPageSizes: PropTypes.arrayOf(PropTypes.number).isRequired
};

var Pager = function Pager(_ref2) {
  var currentPage = _ref2.currentPage,
      onCurrentPageChange = _ref2.onCurrentPageChange,
      totalPages = _ref2.totalPages,
      pageSize = _ref2.pageSize,
      onPageSizeChange = _ref2.onPageSizeChange,
      allowedPageSizes = _ref2.allowedPageSizes;
  return React.createElement(
    'div',
    { className: 'clearfix' },
    !!allowedPageSizes.length && React.createElement(PageSizeSelector, {
      pageSize: pageSize,
      onPageSizeChange: onPageSizeChange,
      allowedPageSizes: allowedPageSizes
    }),
    React.createElement(reactBootstrap.Pagination, {
      style: {
        margin: 0,
        verticalAlign: 'bottom'
      },
      className: 'pull-right',
      items: totalPages,
      activePage: currentPage + 1,
      boundaryLinks: true,
      maxButtons: 3,
      onSelect: function onSelect(page) {
        return onCurrentPageChange(page - 1);
      }
    })
  );
};

Pager.propTypes = {
  currentPage: PropTypes.number.isRequired,
  onCurrentPageChange: PropTypes.func.isRequired,
  totalPages: PropTypes.number.isRequired,
  pageSize: PropTypes.number.isRequired,
  onPageSizeChange: PropTypes.func.isRequired,
  allowedPageSizes: PropTypes.arrayOf(PropTypes.number).isRequired
};

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();





var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};









var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};



















var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var PagingPanel$1 = function PagingPanel$$1(props) {
  return React.createElement(_devexpress_dxReactGrid.PagingPanel, _extends({
    pagerTemplate: Pager
  }, props));
};

var GroupPanel = function GroupPanel(_ref) {
  var groupedColumns = _ref.groupedColumns,
      groupByColumnText = _ref.groupByColumnText,
      cellTemplate = _ref.cellTemplate;

  var text = function text() {
    return groupByColumnText || React.createElement(
      'span',
      null,
      'Click \xA0',
      React.createElement('i', {
        className: 'glyphicon glyphicon-th-list',
        style: {
          top: '0',
          fontSize: '9px'
        }
      }),
      '\xA0 icon in the column header to group by that column'
    );
  };

  var GroupPanelCell = cellTemplate;

  return groupedColumns.length ? React.createElement(
    'div',
    null,
    groupedColumns.map(function (column) {
      return React.createElement(GroupPanelCell, {
        key: column.name,
        column: column
      });
    })
  ) : React.createElement(
    'span',
    null,
    text()
  );
};

GroupPanel.propTypes = {
  groupedColumns: PropTypes.array.isRequired,
  groupByColumnText: PropTypes.string,
  cellTemplate: PropTypes.func.isRequired
};

GroupPanel.defaultProps = {
  groupByColumnText: undefined
};

var SortingIndicator = function SortingIndicator(_ref) {
  var direction = _ref.direction,
      style = _ref.style;
  return React.createElement('i', {
    className: 'glyphicon glyphicon-arrow-' + (direction === 'desc' ? 'down' : 'up'),
    style: _extends({
      top: '0',
      fontSize: '9px'
    }, style)
  });
};

SortingIndicator.propTypes = {
  direction: PropTypes.oneOf(['asc', 'desc']),
  style: PropTypes.shape()
};

SortingIndicator.defaultProps = {
  direction: null,
  style: null
};

var GroupPanelCell = function GroupPanelCell(_ref) {
  var column = _ref.column,
      groupByColumn = _ref.groupByColumn,
      allowSorting = _ref.allowSorting,
      sortingDirection = _ref.sortingDirection,
      changeSortingDirection = _ref.changeSortingDirection;
  return React.createElement(
    'div',
    {
      className: 'btn btn-default',
      style: {
        marginRight: '5px'
      }
    },
    React.createElement(
      'span',
      {
        onClick: function onClick(e) {
          if (!allowSorting) return;
          var cancelSortingRelatedKey = e.metaKey || e.ctrlKey;
          changeSortingDirection({
            keepOther: e.shiftKey || cancelSortingRelatedKey,
            cancel: cancelSortingRelatedKey
          });
        }
      },
      column.title,
      allowSorting && sortingDirection && React.createElement(
        'span',
        null,
        '\xA0',
        React.createElement(SortingIndicator, {
          direction: sortingDirection
        })
      )
    ),
    '\xA0',
    React.createElement('i', {
      className: 'glyphicon glyphicon-remove',
      style: {
        top: '0',
        fontSize: '9px',
        margin: '-5px',
        padding: '5px'
      },
      onClick: function onClick() {
        return groupByColumn({ columnName: column.name });
      }
    })
  );
};

GroupPanelCell.defaultProps = {
  allowSorting: false,
  sortingDirection: undefined,
  changeSortingDirection: undefined,
  allowGrouping: false,
  groupByColumn: undefined
};

GroupPanelCell.propTypes = {
  column: PropTypes.shape({
    title: PropTypes.string
  }).isRequired,
  allowSorting: PropTypes.bool,
  sortingDirection: PropTypes.oneOf(['asc', 'desc', null]),
  changeSortingDirection: PropTypes.func,
  groupByColumn: PropTypes.func
};

var GroupingPanel$1 = function GroupingPanel$$1(_ref) {
  var groupByColumnText = _ref.groupByColumnText,
      restProps = objectWithoutProperties(_ref, ['groupByColumnText']);
  return React.createElement(_devexpress_dxReactGrid.GroupingPanel, _extends({
    groupPanelTemplate: function groupPanelTemplate(props) {
      return React.createElement(GroupPanel, _extends({
        groupByColumnText: groupByColumnText
      }, props));
    },
    groupPanelCellTemplate: GroupPanelCell
  }, restProps));
};

GroupingPanel$1.propTypes = {
  allowSorting: PropTypes.bool,
  groupByColumnText: PropTypes.string
};
GroupingPanel$1.defaultProps = {
  allowSorting: false,
  groupByColumnText: undefined
};

var TableDetailToggleCell = function TableDetailToggleCell(_ref) {
  var style = _ref.style,
      expanded = _ref.expanded,
      toggleExpanded = _ref.toggleExpanded;
  return React.createElement(
    'td',
    {
      style: _extends({
        cursor: 'pointer'
      }, style),
      onClick: function onClick(e) {
        e.stopPropagation();
        toggleExpanded();
      }
    },
    React.createElement('i', {
      className: 'glyphicon glyphicon-triangle-' + (expanded ? 'bottom' : 'right'),
      style: {
        fontSize: '9px',
        top: '0'
      }
    })
  );
};

TableDetailToggleCell.propTypes = {
  style: PropTypes.shape(),
  expanded: PropTypes.bool,
  toggleExpanded: PropTypes.func
};

TableDetailToggleCell.defaultProps = {
  style: null,
  expanded: false,
  toggleExpanded: function toggleExpanded() {}
};

var TableDetailCell = function TableDetailCell(_ref) {
  var colspan = _ref.colspan,
      style = _ref.style,
      template = _ref.template;
  return React.createElement(
    'td',
    { style: style, colSpan: colspan, className: 'active' },
    template()
  );
};

TableDetailCell.propTypes = {
  style: PropTypes.shape(),
  colspan: PropTypes.number,
  template: PropTypes.func.isRequired
};

TableDetailCell.defaultProps = {
  style: null,
  colspan: 1
};

var TableRowDetail$1 = function TableRowDetail$$1(props) {
  return React.createElement(_devexpress_dxReactGrid.TableRowDetail, _extends({
    detailToggleTemplate: TableDetailToggleCell,
    detailCellTemplate: TableDetailCell
  }, props));
};

var TableGroupRowCell = function TableGroupRowCell(_ref) {
  var style = _ref.style,
      colspan = _ref.colspan,
      row = _ref.row,
      isExpanded = _ref.isExpanded,
      toggleGroupExpanded = _ref.toggleGroupExpanded;
  return React.createElement(
    'td',
    {
      colSpan: colspan,
      style: _extends({
        cursor: 'pointer'
      }, style),
      onClick: toggleGroupExpanded
    },
    React.createElement('i', {
      className: 'glyphicon glyphicon-triangle-' + (isExpanded ? 'bottom' : 'right'),
      style: {
        fontSize: '9px',
        top: '0',
        marginRight: '8px'
      }
    }),
    React.createElement(
      'strong',
      null,
      row.column.title,
      ': ',
      row.value
    )
  );
};

TableGroupRowCell.propTypes = {
  style: PropTypes.shape(),
  colspan: PropTypes.number,
  row: PropTypes.shape(),
  isExpanded: PropTypes.bool,
  toggleGroupExpanded: PropTypes.func
};

TableGroupRowCell.defaultProps = {
  style: null,
  colspan: 1,
  row: {},
  isExpanded: false,
  toggleGroupExpanded: function toggleGroupExpanded() {}
};

var TableGroupRow$1 = function TableGroupRow$$1(props) {
  return React.createElement(_devexpress_dxReactGrid.TableGroupRow, _extends({
    groupRowCellTemplate: TableGroupRowCell
  }, props));
};

var TableSelectAllCell = function TableSelectAllCell(_ref) {
  var style = _ref.style,
      allSelected = _ref.allSelected,
      someSelected = _ref.someSelected,
      selectionAvailable = _ref.selectionAvailable,
      toggleAll = _ref.toggleAll;
  return React.createElement(
    'th',
    {
      style: _extends({
        cursor: selectionAvailable && 'pointer'
      }, style),
      onClick: function onClick(e) {
        if (!selectionAvailable) return;

        e.stopPropagation();
        toggleAll();
      }
    },
    React.createElement('input', {
      style: {
        cursor: selectionAvailable && 'pointer',
        margin: 0
      },
      type: 'checkbox',
      disabled: !selectionAvailable,
      checked: allSelected,
      ref: function ref(_ref2) {
        if (_ref2) {
          var checkbox = _ref2;
          checkbox.indeterminate = someSelected;
        }
      },
      onChange: toggleAll,
      onClick: function onClick(e) {
        return e.stopPropagation();
      }
    })
  );
};
TableSelectAllCell.defaultProps = {
  style: null,
  allSelected: false,
  someSelected: false,
  selectionAvailable: false,
  toggleAll: function toggleAll() {}
};
TableSelectAllCell.propTypes = {
  style: PropTypes.shape(),
  allSelected: PropTypes.bool,
  someSelected: PropTypes.bool,
  selectionAvailable: PropTypes.bool,
  toggleAll: PropTypes.func
};

var TableSelectCell = function TableSelectCell(_ref) {
  var style = _ref.style,
      selected = _ref.selected,
      changeSelected = _ref.changeSelected;
  return React.createElement(
    'td',
    {
      style: _extends({
        cursor: 'pointer'
      }, style),
      onClick: function onClick(e) {
        e.stopPropagation();
        changeSelected();
      }
    },
    React.createElement('input', {
      style: {
        cursor: 'pointer',
        margin: 0
      },
      type: 'checkbox',
      checked: selected,
      onChange: changeSelected,
      onClick: function onClick(e) {
        return e.stopPropagation();
      }
    })
  );
};
TableSelectCell.defaultProps = {
  style: null,
  selected: false,
  changeSelected: function changeSelected() {}
};
TableSelectCell.propTypes = {
  style: PropTypes.shape(),
  selected: PropTypes.bool,
  changeSelected: PropTypes.func
};

var TableSelection$1 = function TableSelection$$1(props) {
  return React.createElement(_devexpress_dxReactGrid.TableSelection, _extends({
    selectCellTemplate: TableSelectCell,
    selectAllCellTemplate: TableSelectAllCell
  }, props));
};

/* globals document */

var querySelectorAll = function () {
  var scopeSupported = true;
  try {
    document.createElement('a').querySelector(':scope *');
  } catch (e) {
    scopeSupported = false;
  }

  if (scopeSupported) {
    return function (element, selectors) {
      return element.querySelectorAll(selectors);
    };
  }

  var scope = /:scope\b/gi;
  return function (element, selectors) {
    var el = element;
    var hasScope = selectors && scope.test(selectors);

    if (hasScope) {
      var id = el.getAttribute('id');

      if (!id) {
        el.id = 'q' + Math.floor(Math.random() * 9000000) + 1000000;
      }

      var elementOrNodeList = el.querySelectorAll(selectors.replace(scope, '#' + el.id));

      if (id === null) {
        el.removeAttribute('id');
      } else if (!id) {
        el.id = id;
      }

      return elementOrNodeList;
    }

    return el.querySelectorAll(selectors);
  };
}();

var MINIMAL_COLUMN_WIDTH = 120;

var getKeyGetter = function getKeyGetter(getIntrinsicKey) {
  return function (object, index) {
    var intrinsicKey = getIntrinsicKey(object);
    var type = object.type || 'data';
    var key = intrinsicKey === undefined ? '$' + index : intrinsicKey;
    return type + '_' + key;
  };
};

var getCellInfo = function getCellInfo(_ref) {
  var row = _ref.row,
      columnIndex = _ref.columnIndex,
      columns = _ref.columns;

  if (row.colspan !== undefined && columnIndex > row.colspan) {
    return { skip: true };
  }
  var colspan = row.colspan === columnIndex ? columns.length - row.colspan : 1;
  return { colspan: colspan };
};

var TableRow = function TableRow(props) {
  var row = props.row,
      columns = props.columns,
      cellTemplate = props.cellTemplate;

  var TableCell = cellTemplate;
  var columnKeyGetter = getKeyGetter(function (column) {
    return column.name;
  });

  var height = !row.height || row.height === 'auto' ? 'auto' : row.height + 'px';
  return React.createElement(
    'tr',
    {
      className: row.selected ? 'active' : '',
      style: { height: height }
    },
    columns.map(function (column, columnIndex) {
      var info = getCellInfo({ row: row, column: column, columnIndex: columnIndex, columns: columns });
      if (info.skip) return null;
      return React.createElement(TableCell, {
        key: columnKeyGetter(column, columnIndex),
        row: row,
        column: column,
        colspan: info.colspan,
        style: column.width ? { width: column.width } : null
      });
    })
  );
};

TableRow.propTypes = {
  row: PropTypes.object.isRequired,
  columns: PropTypes.array.isRequired,
  cellTemplate: PropTypes.func.isRequired
};

TableRow.defaultProps = {
  isHeader: false
};

var Table = function Table(_ref2) {
  var headerRows = _ref2.headerRows,
      bodyRows = _ref2.bodyRows,
      columns = _ref2.columns,
      cellTemplate = _ref2.cellTemplate,
      _onClick = _ref2.onClick,
      getRowId = _ref2.getRowId;

  var rowKeyGetter = getKeyGetter(function (row) {
    return !row.type ? getRowId(row) : row.id;
  });
  var minWidth = columns.map(function (column) {
    return column.width || MINIMAL_COLUMN_WIDTH;
  }).reduce(function (accum, minColumnWidth) {
    return accum + minColumnWidth;
  }, 0);

  return React.createElement(
    'div',
    {
      className: 'table-responsive',
      style: {
        WebkitOverflowScrolling: 'touch'
      }
    },
    React.createElement(
      'table',
      {
        className: 'table',
        style: {
          tableLayout: 'fixed',
          minWidth: minWidth + 'px'
        },
        onClick: function onClick(e) {
          var target = e.target,
              currentTarget = e.currentTarget;


          var rowsEls = querySelectorAll(currentTarget, ':scope > thead > tr, :scope > tbody > tr');
          var rowIndex = [].concat(toConsumableArray(rowsEls)).findIndex(function (rowEl) {
            return rowEl.contains(target);
          });
          if (rowIndex === -1) return;
          var cellEls = querySelectorAll(rowsEls[rowIndex], ':scope > th, :scope > td');
          var columnIndex = [].concat(toConsumableArray(cellEls)).findIndex(function (cellEl) {
            return cellEl.contains(target);
          });
          if (columnIndex === -1) return;

          var row = [].concat(toConsumableArray(headerRows), toConsumableArray(bodyRows))[rowIndex];
          var column = columns[columnIndex];
          _onClick({ row: row, column: column, e: e });
        }
      },
      React.createElement(
        'thead',
        null,
        headerRows.map(function (row, rowIndex) {
          return React.createElement(TableRow, {
            key: rowKeyGetter(row, rowIndex),
            row: row,
            columns: columns,
            cellTemplate: cellTemplate
          });
        })
      ),
      React.createElement(
        'tbody',
        null,
        bodyRows.map(function (row, rowIndex) {
          return React.createElement(TableRow, {
            key: rowKeyGetter(row, rowIndex),
            row: row,
            columns: columns,
            cellTemplate: cellTemplate
          });
        })
      )
    )
  );
};
Table.defaultProps = {
  onClick: function onClick() {}
};
Table.propTypes = {
  headerRows: PropTypes.array.isRequired,
  bodyRows: PropTypes.array.isRequired,
  columns: PropTypes.array.isRequired,
  cellTemplate: PropTypes.func.isRequired,
  getRowId: PropTypes.func.isRequired,
  onClick: PropTypes.func
};

var TableCell = function TableCell(_ref) {
  var style = _ref.style,
      row = _ref.row,
      column = _ref.column;
  return React.createElement(
    'td',
    {
      style: _extends({
        whiteSpace: 'nowrap',
        overflow: 'hidden',
        textOverflow: 'ellipsis',
        textAlign: column.align || 'left'
      }, style)
    },
    row[column.name]
  );
};

TableCell.propTypes = {
  style: PropTypes.shape(),
  row: PropTypes.shape(),
  column: PropTypes.shape()
};

TableCell.defaultProps = {
  style: null,
  row: {},
  column: {}
};

var TableNoDataCell = function TableNoDataCell(_ref) {
  var style = _ref.style,
      colspan = _ref.colspan;
  return React.createElement(
    'td',
    {
      style: _extends({
        textAlign: 'center',
        padding: '40px 0'
      }, style),
      colSpan: colspan
    },
    React.createElement(
      'big',
      { className: 'text-muted' },
      'No data'
    )
  );
};

TableNoDataCell.propTypes = {
  style: PropTypes.shape(),
  colspan: PropTypes.number
};

TableNoDataCell.defaultProps = {
  style: null,
  colspan: 1
};

var Layout = function Layout() {
  return React.createElement(
    _devexpress_dxReactCore.PluginContainer,
    null,
    React.createElement(_devexpress_dxReactCore.Template, { name: 'gridHeading' }),
    React.createElement(_devexpress_dxReactCore.Template, { name: 'gridFooter' }),
    React.createElement(
      _devexpress_dxReactCore.Template,
      { name: 'root' },
      React.createElement(
        'div',
        { className: 'panel panel-default' },
        React.createElement(
          _devexpress_dxReactCore.TemplatePlaceholder,
          { name: 'gridHeading' },
          function (content) {
            return !content ? null : React.createElement(
              'div',
              { className: 'panel-heading' },
              content
            );
          }
        ),
        React.createElement(_devexpress_dxReactCore.TemplatePlaceholder, { name: 'gridBody' }),
        React.createElement(
          _devexpress_dxReactCore.TemplatePlaceholder,
          { name: 'gridFooter' },
          function (content) {
            return !content ? null : React.createElement(
              'div',
              { className: 'panel-footer' },
              content
            );
          }
        )
      )
    )
  );
};

var TableView$1 = function TableView$$1(_ref) {
  var tableCellTemplate = _ref.tableCellTemplate,
      props = objectWithoutProperties(_ref, ['tableCellTemplate']);
  return React.createElement(
    _devexpress_dxReactCore.PluginContainer,
    null,
    React.createElement(_devexpress_dxReactGrid.TableView, _extends({
      tableTemplate: Table,
      tableCellTemplate: _devexpress_dxReactCore.combineTemplates(tableCellTemplate, TableCell),
      tableNoDataCellTemplate: TableNoDataCell
    }, props)),
    React.createElement(Layout, null)
  );
};
TableView$1.propTypes = {
  tableCellTemplate: PropTypes.func
};
TableView$1.defaultProps = {
  tableCellTemplate: undefined
};

/* global requestAnimationFrame cancelAnimationFrame */

var Sizer = function (_React$Component) {
  inherits(Sizer, _React$Component);

  function Sizer() {
    classCallCheck(this, Sizer);
    return possibleConstructorReturn(this, (Sizer.__proto__ || Object.getPrototypeOf(Sizer)).apply(this, arguments));
  }

  createClass(Sizer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var watchSizes = function watchSizes() {
        var rect = _this2.root.getBoundingClientRect();
        _this2.sizeUpdated(rect.width, rect.height);
        _this2._raf = requestAnimationFrame(watchSizes);
      };
      watchSizes();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      cancelAnimationFrame(this._raf);
    }
  }, {
    key: 'sizeUpdated',
    value: function sizeUpdated(newWidth, newHeight) {
      var _props = this.props,
          height = _props.height,
          onHeightChange = _props.onHeightChange,
          width = _props.width,
          onWidthChange = _props.onWidthChange;


      if (height !== undefined && newHeight !== height) {
        onHeightChange(newHeight);
      }
      if (width !== undefined && newWidth !== width) {
        onWidthChange(newWidth);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          children = _props2.children,
          height = _props2.height,
          onHeightChange = _props2.onHeightChange,
          width = _props2.width,
          onWidthChange = _props2.onWidthChange,
          restProps = objectWithoutProperties(_props2, ['children', 'height', 'onHeightChange', 'width', 'onWidthChange']);


      return React.createElement(
        'div',
        _extends({ ref: function ref(_ref) {
            _this3.root = _ref;
          } }, restProps),
        children
      );
    }
  }]);
  return Sizer;
}(React.Component);
Sizer.defaultProps = {
  height: undefined,
  onHeightChange: function onHeightChange() {},
  width: undefined,
  onWidthChange: function onWidthChange() {}
};
Sizer.propTypes = {
  height: PropTypes.number,
  onHeightChange: PropTypes.func,
  width: PropTypes.number,
  onWidthChange: PropTypes.func,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]).isRequired
};

/* global navigator requestAnimationFrame */

var isSafari = /Safari/.test(navigator.userAgent) && /Apple Computer/.test(navigator.vendor);

var WindowedScroller = function (_React$Component) {
  inherits(WindowedScroller, _React$Component);

  function WindowedScroller(props) {
    classCallCheck(this, WindowedScroller);

    var _this = possibleConstructorReturn(this, (WindowedScroller.__proto__ || Object.getPrototypeOf(WindowedScroller)).call(this, props));

    _this.state = {
      viewport: { top: 0, left: 0, width: 0, height: 0 },
      offsetWidth: 0
    };

    _this.updateViewport = _this.updateViewport.bind(_this);
    return _this;
  }

  createClass(WindowedScroller, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        virtualHost: {
          viewport: this.state.viewport
        }
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        _this2.updateViewport();
      });
    }
  }, {
    key: 'updateViewport',
    value: function updateViewport() {
      if (isSafari) {
        requestAnimationFrame(this._updateViewport.bind(this));
      } else {
        this._updateViewport();
      }
    }
  }, {
    key: '_updateViewport',
    value: function _updateViewport() {
      if (!this.root) return;

      var oldViewport = this.state.viewport;
      var viewport = {
        top: this.root.scrollTop,
        left: this.root.scrollLeft,
        width: this.root.clientWidth,
        height: this.root.clientHeight
      };

      // Prevent iOS to flicker in bounces =(
      if (viewport.top < 0 || viewport.left < 0 || viewport.left + viewport.width > this.root.scrollWidth || viewport.top + viewport.height > this.root.scrollHeight) {
        return;
      }

      // Optimize performance
      if (oldViewport.top !== viewport.top || oldViewport.left !== viewport.left || oldViewport.width !== viewport.width || oldViewport.height !== viewport.height) {
        this.setState({ viewport: viewport });
        this.props.onViewportChange(viewport);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return React.createElement(
        Sizer,
        {
          style: { width: '100%', height: '100%' },
          width: this.state.offsetWidth,
          onWidthChange: function onWidthChange(width) {
            _this3.setState({ offsetWidth: width });
            _this3.updateViewport();
          }
        },
        React.createElement(
          'div',
          {
            ref: function ref(_ref) {
              _this3.root = _ref;
            },
            onScroll: this.updateViewport,
            style: {
              overflow: 'auto',
              width: '100%',
              height: '100%',
              WebkitOverflowScrolling: 'touch',
              willChange: 'scroll-position'
            }
          },
          this.props.children
        )
      );
    }
  }]);
  return WindowedScroller;
}(React.Component);
WindowedScroller.defaultProps = {
  onViewportChange: function onViewportChange() {}
};
WindowedScroller.propTypes = {
  onViewportChange: PropTypes.func,
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]).isRequired
};
WindowedScroller.childContextTypes = {
  virtualHost: PropTypes.object.isRequired
};

/* global document */

function testCSSProp(property, value, noPrefixes) {
  var prop = property + ':';
  var el = document.createElement('test');
  var mStyle = el.style;

  if (!noPrefixes) {
    mStyle.cssText = prop + ['-webkit-', '-moz-', '-ms-', '-o-', ''].join(value + ';' + prop) + value + ';';
  } else {
    mStyle.cssText = prop + value;
  }
  return mStyle[property];
}
var stickyProp = testCSSProp('position', 'sticky');

function getVisibleItems(options) {
  var viewportStart = options.viewport.start;
  var viewportSize = options.viewport.size;

  var visibleItemMetas = [];
  var stickyItemsMetas = [];

  var index = 0;
  var offset = 0;
  while (index < options.itemCount) {
    var itemInfo = options.itemInfo(index);
    var itemSize = itemInfo.size;
    var itemStick = itemInfo.stick;

    if (itemStick === 'before' && offset <= viewportStart) {
      stickyItemsMetas.push({ index: index, offset: offset, size: itemSize, stick: itemStick });
      viewportStart += itemSize;
    }

    if ((offset + itemSize > viewportStart && offset + itemSize < viewportStart + viewportSize || offset < viewportStart + viewportSize && offset > viewportStart || offset <= viewportStart && offset + itemSize >= viewportStart + viewportSize) && itemSize > 0 && itemStick === false) {
      visibleItemMetas.push({ index: index, offset: offset, size: itemSize, stick: false });
    }

    index += 1;
    offset += itemSize;
  }

  return {
    visibleItemMetas: [].concat(stickyItemsMetas, visibleItemMetas),
    fullSize: offset,
    stickyBeforeSize: stickyItemsMetas.reduce(function (accumulator, meta) {
      return accumulator + meta.size;
    }, 0)
  };
}

var VirtualBox = function (_React$Component) {
  inherits(VirtualBox, _React$Component);

  function VirtualBox() {
    classCallCheck(this, VirtualBox);
    return possibleConstructorReturn(this, (VirtualBox.__proto__ || Object.getPrototypeOf(VirtualBox)).apply(this, arguments));
  }

  createClass(VirtualBox, [{
    key: 'getChildContext',
    value: function getChildContext() {
      var _viewport;

      var _props = this.props,
          direction = _props.direction,
          position = _props.position,
          stick = _props.stick;

      var viewport = this.context.virtualHost.viewport;

      var positionProp = direction === 'horizontal' ? 'left' : 'top';
      var crossPositionProp = direction === 'horizontal' ? 'top' : 'left';
      var sizeProp = direction === 'horizontal' ? 'width' : 'height';
      var crossSizeProp = direction === 'horizontal' ? 'height' : 'width';

      return {
        virtualHost: {
          viewport: (_viewport = {}, defineProperty(_viewport, positionProp, stick ? position : Math.max(viewport[positionProp] - position, 0)), defineProperty(_viewport, crossPositionProp, viewport[crossPositionProp]), defineProperty(_viewport, sizeProp, stick ? viewport[sizeProp] : Math.min(viewport[positionProp] + viewport[sizeProp] - position, viewport[sizeProp])), defineProperty(_viewport, crossSizeProp, viewport[crossSizeProp]), _viewport)
        }
      };
    }
  }, {
    key: 'getItemStyles',
    value: function getItemStyles(_ref) {
      var _babelHelpers$extends2;

      var position = _ref.position,
          size = _ref.size,
          stick = _ref.stick;
      var _props2 = this.props,
          direction = _props2.direction,
          crossSize = _props2.crossSize;

      var viewport = this.context.virtualHost.viewport;

      var positionProp = direction === 'horizontal' ? 'left' : 'top';
      var sizeProp = direction === 'horizontal' ? 'width' : 'height';
      var crossSizeProp = direction === 'vertical' ? 'width' : 'height';

      var styles = defineProperty({
        position: 'absolute'
      }, positionProp, position + 'px');

      if (stick) {
        if (stickyProp) {
          styles = _extends({}, styles, defineProperty({

            zIndex: 1,
            position: stickyProp
          }, positionProp, position + (viewport[positionProp + 'Stick'] || 0) + 'px'));
        } else if (direction === 'vertical') {
          var _styles2;

          styles = (_styles2 = {
            zIndex: 1,
            position: 'fixed'
          }, defineProperty(_styles2, crossSizeProp, viewport[crossSizeProp] + 'px'), defineProperty(_styles2, 'overflow', 'hidden'), defineProperty(_styles2, 'WebkitBackfaceVisibility', 'hidden'), defineProperty(_styles2, 'backfaceVisibility', 'hidden'), _styles2);
          /* children = (
              <div
                style={{
                  marginLeft: -viewport[crossPositionProp] + 'px',
                  width: '100%',
                  height: '100%'
                }}
              >
                  {children}
              </div>
          );*/
        }
      }

      return _extends({}, styles, (_babelHelpers$extends2 = {
        display: 'block'
      }, defineProperty(_babelHelpers$extends2, sizeProp, size + 'px'), defineProperty(_babelHelpers$extends2, crossSizeProp, crossSize + 'px'), _babelHelpers$extends2));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this,
          _babelHelpers$extends3;

      var _props3 = this.props,
          direction = _props3.direction,
          position = _props3.position,
          stick = _props3.stick,
          iref = _props3.iref;

      var viewport = this.context.virtualHost.viewport;

      var positionProp = direction === 'horizontal' ? 'left' : 'top';
      var sizeProp = direction === 'horizontal' ? 'width' : 'height';

      var _getVisibleItems = getVisibleItems({
        viewport: { start: stick ? position : viewport[positionProp], size: viewport[sizeProp] },
        itemCount: this.props.itemCount,
        itemInfo: this.props.itemInfo
      }),
          visibleItemMetas = _getVisibleItems.visibleItemMetas,
          fullSize = _getVisibleItems.fullSize;

      var visibleItems = visibleItemMetas.map(function (visibleItemMeta) {
        var styles = _this2.getItemStyles({
          position: visibleItemMeta.offset,
          size: visibleItemMeta.size,
          stick: visibleItemMeta.stick
        });

        return React.cloneElement(_this2.props.itemTemplate(visibleItemMeta.index, visibleItemMeta.offset, styles), {
          key: '' + visibleItemMeta.index,
          style: styles
        });
      });

      var RootTag = this.props.rootTag;

      return React.createElement(
        RootTag,
        _extends({
          className: this.props.className,
          style: _extends({
            position: 'relative'
          }, this.props.style, (_babelHelpers$extends3 = {}, defineProperty(_babelHelpers$extends3, sizeProp, fullSize + 'px'), defineProperty(_babelHelpers$extends3, 'display', 'block'), _babelHelpers$extends3))
        }, iref ? { ref: iref } : {}),
        visibleItems
      );
    }
  }]);
  return VirtualBox;
}(React.Component);
VirtualBox.defaultProps = {
  rootTag: 'div',
  className: '',
  style: {},
  position: 0,
  stick: false,
  crossSize: 0,
  iref: undefined
};
VirtualBox.propTypes = {
  rootTag: PropTypes.string,
  className: PropTypes.string,
  style: PropTypes.object,
  position: PropTypes.number,
  stick: PropTypes.bool,
  iref: PropTypes.func,
  crossSize: PropTypes.number,
  direction: PropTypes.oneOf(['vertical', 'horizontal']).isRequired,
  itemCount: PropTypes.number.isRequired,
  itemInfo: PropTypes.func.isRequired,
  itemTemplate: PropTypes.func.isRequired
};
VirtualBox.contextTypes = {
  virtualHost: PropTypes.object
};
VirtualBox.childContextTypes = {
  virtualHost: PropTypes.object.isRequired
};

/* global window document */

var DEFAULT_HEIGHT = 37;
var MINIMAL_COLUMN_WIDTH$1 = 120;

var calculateColumnWidths = function calculateColumnWidths(columns, tableWidth) {
  var occupiedWidth = columns.map(function (column) {
    return column.width;
  }).filter(function (width) {
    return !!width;
  }).reduce(function (accum, width) {
    return accum + width;
  }, 0);
  var restWidthSpread = columns.map(function (column) {
    return column.width;
  }).filter(function (width) {
    return !width;
  }).length;
  var calculatedWidth = (tableWidth - occupiedWidth) / restWidthSpread;
  var widthForAutoColumn = Math.max(calculatedWidth, MINIMAL_COLUMN_WIDTH$1);

  return columns.map(function (column) {
    return column.width;
  }).map(function (width) {
    return !!width && width !== 'auto' ? width : widthForAutoColumn;
  });
};

var VirtualTable = function (_React$Component) {
  inherits(VirtualTable, _React$Component);

  function VirtualTable(props) {
    classCallCheck(this, VirtualTable);

    var _this = possibleConstructorReturn(this, (VirtualTable.__proto__ || Object.getPrototypeOf(VirtualTable)).call(this, props));

    _this.state = {
      viewportWidth: 0,
      autoHeights: new WeakMap()
    };

    _this.rowHeight = function (row) {
      var height = row.height || DEFAULT_HEIGHT;
      if (height === 'auto') {
        height = DEFAULT_HEIGHT;
      }
      return height;
    };
    return _this;
  }

  createClass(VirtualTable, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          headerRows = _props.headerRows,
          bodyRows = _props.bodyRows,
          columns = _props.columns,
          cellTemplate = _props.cellTemplate;


      var columnWidths = calculateColumnWidths(columns, this.state.viewportWidth);
      var scrollWidth = columnWidths.reduce(function (accum, width) {
        return accum + width;
      }, 0);

      var tableRow = function tableRow(row, position) {
        var colspan = row.colspan;
        var columnLength = colspan !== undefined ? colspan + 1 : columns.length;
        return React.createElement(VirtualBox, {
          rootTag: 'tr',

          position: position,
          crossSize: _this2.rowHeight(row),
          direction: 'horizontal',
          itemCount: columnLength,
          itemInfo: function itemInfo(columnIndex) {
            var size = columnIndex !== colspan ? columnWidths[columnIndex] : columns.slice(colspan).reduce(function (accum, column) {
              return accum + columnWidths[columns.indexOf(column)];
            }, 0);

            return {
              size: size,
              stick: false
            };
          },
          itemTemplate: function itemTemplate(columnIndex, _, style) {
            return cellTemplate({ row: row, column: columns[columnIndex], style: style });
          }
        });
      };

      var tableHead = function tableHead(position) {
        return React.createElement(VirtualBox, {
          key: 'thead',
          rootTag: 'thead',

          iref: function iref(ref) {
            if (!ref) return;
            var style = ref.style;

            style.backgroundColor = window.getComputedStyle(document.body).backgroundColor;
          },

          position: position,
          stick: true,
          direction: 'vertical',
          itemCount: headerRows.length,
          itemInfo: function itemInfo(rowIndex) {
            return {
              size: _this2.rowHeight(headerRows[rowIndex]),
              stick: false
            };
          },
          itemTemplate: function itemTemplate(rowIndex, rowPosition) {
            return tableRow(headerRows[rowIndex], rowPosition);
          }
        });
      };

      var tableBody = function tableBody(position) {
        return React.createElement(VirtualBox, {
          key: 'tbody',
          rootTag: 'tbody',

          position: position,
          direction: 'vertical',
          itemCount: bodyRows.length,
          itemInfo: function itemInfo(rowIndex) {
            return {
              size: _this2.rowHeight(bodyRows[rowIndex]),
              stick: false
            };
          },
          itemTemplate: function itemTemplate(rowIndex, rowPosition) {
            return tableRow(bodyRows[rowIndex], rowPosition);
          }
        });
      };

      return React.createElement(
        'div',
        {
          style: { height: '530px' }
        },
        React.createElement(
          WindowedScroller,
          {
            onViewportChange: function onViewportChange(viewport) {
              return _this2.setState({ viewportWidth: viewport.width });
            }
          },
          React.createElement(VirtualBox, {
            rootTag: 'table',
            className: 'table',
            style: { zIndex: 0 },

            crossSize: scrollWidth,
            direction: 'vertical',
            itemCount: 2,
            itemInfo: function itemInfo(rowIndex) {
              var size = rowIndex === 0 ? headerRows.reduce(function (accum, row) {
                return accum + _this2.rowHeight(row);
              }, 0) : bodyRows.reduce(function (accum, row) {
                return accum + _this2.rowHeight(row);
              }, 0);

              return {
                size: size,
                stick: rowIndex === 0 ? 'before' : false
              };
            },
            itemTemplate: function itemTemplate(rowIndex, position) {
              return rowIndex === 0 ? tableHead(position) : tableBody(position);
            }
          })
        )
      );
    }
  }]);
  return VirtualTable;
}(React.Component);

VirtualTable.propTypes = {
  headerRows: PropTypes.array.isRequired,
  bodyRows: PropTypes.array.isRequired,
  columns: PropTypes.array.isRequired,
  cellTemplate: PropTypes.func.isRequired
};

var VirtualTableView = function VirtualTableView(_ref) {
  var tableCellTemplate = _ref.tableCellTemplate,
      props = objectWithoutProperties(_ref, ['tableCellTemplate']);
  return React.createElement(
    _devexpress_dxReactCore.PluginContainer,
    null,
    React.createElement(_devexpress_dxReactGrid.TableView, _extends({
      tableTemplate: VirtualTable,
      tableCellTemplate: _devexpress_dxReactCore.combineTemplates(tableCellTemplate, TableCell),
      tableNoDataCellTemplate: TableNoDataCell
    }, props)),
    React.createElement(Layout, null)
  );
};
VirtualTableView.propTypes = {
  tableCellTemplate: PropTypes.func
};
VirtualTableView.defaultProps = {
  tableCellTemplate: undefined
};

var TableFilterCell = function TableFilterCell(_ref) {
  var style = _ref.style,
      column = _ref.column,
      filter = _ref.filter,
      setFilter = _ref.setFilter;
  return React.createElement(
    'th',
    {
      style: _extends({
        fontWeight: 'normal'
      }, style)
    },
    !column.type && React.createElement('input', {
      type: 'text',
      className: 'form-control',
      value: filter ? filter.value : '',
      onChange: function onChange(e) {
        return setFilter({ value: e.target.value });
      }
    })
  );
};

TableFilterCell.propTypes = {
  column: PropTypes.shape(),
  style: PropTypes.shape(),
  filter: PropTypes.string,
  setFilter: PropTypes.func
};

TableFilterCell.defaultProps = {
  column: {},
  style: null,
  filter: '',
  setFilter: function setFilter() {}
};

var TableFilterRow$1 = function TableFilterRow$$1(_ref) {
  var filterCellTemplate = _ref.filterCellTemplate,
      restProps = objectWithoutProperties(_ref, ['filterCellTemplate']);
  return React.createElement(_devexpress_dxReactGrid.TableFilterRow, _extends({
    filterCellTemplate: _devexpress_dxReactCore.combineTemplates(filterCellTemplate, TableFilterCell)
  }, restProps));
};

TableFilterRow$1.propTypes = {
  filterCellTemplate: PropTypes.func
};
TableFilterRow$1.defaultProps = {
  filterCellTemplate: undefined
};

var TableHeaderCell = function TableHeaderCell(_ref) {
  var _ref2;

  var style = _ref.style,
      column = _ref.column,
      allowSorting = _ref.allowSorting,
      sortingDirection = _ref.sortingDirection,
      changeSortingDirection = _ref.changeSortingDirection,
      allowGrouping = _ref.allowGrouping,
      groupByColumn = _ref.groupByColumn;

  var align = column.align || 'left';
  var invertedAlign = align === 'left' ? 'right' : 'left';

  var gropingControl = allowGrouping && React.createElement(
    'div',
    {
      onClick: function onClick(e) {
        e.stopPropagation();
        groupByColumn(e);
      },
      style: {
        float: invertedAlign,
        textAlign: invertedAlign,
        width: '14px'
      }
    },
    React.createElement('i', {
      className: 'glyphicon glyphicon-th-list',
      style: {
        top: '0',
        fontSize: '9px',
        margin: '-5px',
        padding: '5px'
      }
    })
  );

  var sortingControl = allowSorting && (align === 'right' ? React.createElement(
    'span',
    {
      className: sortingDirection ? 'text-primary' : ''
    },
    React.createElement(SortingIndicator, {
      direction: sortingDirection,
      style: { visibility: sortingDirection ? 'visible' : 'hidden' }
    }),
    '\xA0',
    column.title
  ) : React.createElement(
    'span',
    {
      className: sortingDirection ? 'text-primary' : ''
    },
    column.title,
    '\xA0',
    React.createElement(SortingIndicator, {
      direction: sortingDirection,
      style: { visibility: sortingDirection ? 'visible' : 'hidden' }
    })
  ));

  return React.createElement(
    'th',
    {
      style: _extends({
        userSelect: 'none',
        MozUserSelect: 'none',
        WebkitUserSelect: 'none',
        cursor: allowSorting && !column.type && 'pointer'
      }, style),
      onClick: function onClick(e) {
        if (!allowSorting) return;
        e.stopPropagation();
        var cancelSortingRelatedKey = e.metaKey || e.ctrlKey;
        changeSortingDirection({
          keepOther: e.shiftKey || cancelSortingRelatedKey,
          cancel: cancelSortingRelatedKey
        });
      }
    },
    gropingControl,
    React.createElement(
      'div',
      {
        style: (_ref2 = {}, defineProperty(_ref2, 'margin' + (column.align === 'right' ? 'Left' : 'Right'), '14px'), defineProperty(_ref2, 'textAlign', align), defineProperty(_ref2, 'whiteSpace', 'nowrap'), defineProperty(_ref2, 'overflow', 'hidden'), defineProperty(_ref2, 'textOverflow', 'ellipsis'), _ref2)
      },
      allowSorting ? sortingControl : column.title
    )
  );
};
TableHeaderCell.defaultProps = {
  style: null,
  allowSorting: false,
  sortingDirection: undefined,
  changeSortingDirection: undefined,
  allowGrouping: false,
  groupByColumn: undefined
};
TableHeaderCell.propTypes = {
  column: PropTypes.shape({
    title: PropTypes.string
  }).isRequired,
  style: PropTypes.shape(),
  allowSorting: PropTypes.bool,
  sortingDirection: PropTypes.oneOf(['asc', 'desc', null]),
  changeSortingDirection: PropTypes.func,
  allowGrouping: PropTypes.bool,
  groupByColumn: PropTypes.func
};

var TableHeaderRow$1 = function TableHeaderRow$$1(_ref) {
  var allowSorting = _ref.allowSorting,
      allowGrouping = _ref.allowGrouping;
  return React.createElement(_devexpress_dxReactGrid.TableHeaderRow, {
    headerCellTemplate: TableHeaderCell,
    allowSorting: allowSorting,
    allowGrouping: allowGrouping
  });
};

TableHeaderRow$1.defaultProps = {
  allowSorting: false,
  allowGrouping: false
};

TableHeaderRow$1.propTypes = {
  allowSorting: PropTypes.bool,
  allowGrouping: PropTypes.bool
};

var EditCell = function EditCell(_ref) {
  var column = _ref.column,
      value = _ref.value,
      onValueChange = _ref.onValueChange;
  return React.createElement(
    'td',
    {
      style: {
        verticalAlign: 'middle',
        padding: 1
      }
    },
    React.createElement('input', {
      type: 'text',
      className: 'form-control',
      value: value,
      onChange: function onChange(e) {
        return onValueChange(e.target.value);
      },
      style: { width: '100%', textAlign: column.align }
    })
  );
};
EditCell.propTypes = {
  column: PropTypes.object.isRequired,
  value: PropTypes.any,
  onValueChange: PropTypes.func.isRequired
};
EditCell.defaultProps = {
  value: undefined
};

var TableEditRow$1 = function TableEditRow$$1(_ref) {
  var editCellTemplate = _ref.editCellTemplate,
      restProps = objectWithoutProperties(_ref, ['editCellTemplate']);
  return React.createElement(_devexpress_dxReactGrid.TableEditRow, _extends({}, restProps, {
    editCellTemplate: _devexpress_dxReactCore.combineTemplates(editCellTemplate, EditCell)
  }));
};
TableEditRow$1.propTypes = {
  editCellTemplate: PropTypes.func
};
TableEditRow$1.defaultProps = {
  editCellTemplate: undefined
};

var CommandButton = function CommandButton(_ref) {
  var executeCommand = _ref.executeCommand,
      text = _ref.text;
  return React.createElement(
    'button',
    {
      className: 'btn btn-link',
      onClick: function onClick(e) {
        executeCommand();
        e.stopPropagation();
      }
    },
    text
  );
};
CommandButton.propTypes = {
  executeCommand: PropTypes.func.isRequired,
  text: PropTypes.func.isRequired
};

var EditCommandHeadingCell = function EditCommandHeadingCell(_ref2) {
  var addRow = _ref2.addRow,
      commandTemplate = _ref2.commandTemplate,
      allowAdding = _ref2.allowAdding,
      _ref2$style = _ref2.style,
      style = _ref2$style === undefined ? {} : _ref2$style,
      _ref2$addCommandText = _ref2.addCommandText,
      addCommandText = _ref2$addCommandText === undefined ? 'New' : _ref2$addCommandText;
  return React.createElement(
    'th',
    {
      style: _extends({
        whiteSpace: 'nowrap',
        textAlign: 'center',
        padding: 0
      }, style)
    },
    allowAdding && commandTemplate({
      id: 'add',
      executeCommand: addRow,
      text: addCommandText
    })
  );
};
EditCommandHeadingCell.propTypes = {
  addRow: PropTypes.func.isRequired,
  commandTemplate: PropTypes.func.isRequired,
  addCommandText: PropTypes.string.isRequired,
  allowAdding: PropTypes.bool.isRequired,
  style: PropTypes.object
};
EditCommandHeadingCell.defaultProps = {
  style: undefined
};

var EditCommandCell = function EditCommandCell(_ref3) {
  var startEditing = _ref3.startEditing,
      deleteRow = _ref3.deleteRow,
      cancelEditing = _ref3.cancelEditing,
      commitChanges = _ref3.commitChanges,
      isEditing = _ref3.isEditing,
      commandTemplate = _ref3.commandTemplate,
      allowEditing = _ref3.allowEditing,
      allowDeleting = _ref3.allowDeleting,
      _ref3$style = _ref3.style,
      style = _ref3$style === undefined ? {} : _ref3$style,
      _ref3$editCommandText = _ref3.editCommandText,
      editCommandText = _ref3$editCommandText === undefined ? 'Edit' : _ref3$editCommandText,
      _ref3$deleteCommandTe = _ref3.deleteCommandText,
      deleteCommandText = _ref3$deleteCommandTe === undefined ? 'Delete' : _ref3$deleteCommandTe,
      _ref3$commitCommandTe = _ref3.commitCommandText,
      commitCommandText = _ref3$commitCommandTe === undefined ? 'Save' : _ref3$commitCommandTe,
      _ref3$cancelCommandTe = _ref3.cancelCommandText,
      cancelCommandText = _ref3$cancelCommandTe === undefined ? 'Cancel' : _ref3$cancelCommandTe;

  var commands = [];
  if (!isEditing) {
    if (allowEditing) {
      commands.push({
        id: 'edit',
        executeCommand: startEditing,
        text: editCommandText
      });
    }
    if (allowDeleting) {
      commands.push({
        id: 'delete',
        executeCommand: deleteRow,
        text: deleteCommandText
      });
    }
  } else {
    commands = [{
      id: 'commit',
      executeCommand: commitChanges,
      text: commitCommandText
    }, {
      id: 'cancel',
      executeCommand: cancelEditing,
      text: cancelCommandText
    }];
  }
  return React.createElement(
    'td',
    {
      style: _extends({
        whiteSpace: 'nowrap',
        textAlign: 'center',
        padding: 0
      }, style)
    },
    commands.map(function (command) {
      return React.createElement(
        'span',
        { key: command.id },
        commandTemplate(command)
      );
    })
  );
};
EditCommandCell.propTypes = {
  startEditing: PropTypes.func.isRequired,
  deleteRow: PropTypes.func.isRequired,
  cancelEditing: PropTypes.func.isRequired,
  commitChanges: PropTypes.func.isRequired,
  isEditing: PropTypes.bool.isRequired,
  allowEditing: PropTypes.bool.isRequired,
  allowDeleting: PropTypes.bool.isRequired,
  commandTemplate: PropTypes.func.isRequired,
  editCommandText: PropTypes.string.isRequired,
  deleteCommandText: PropTypes.string.isRequired,
  commitCommandText: PropTypes.string.isRequired,
  cancelCommandText: PropTypes.string.isRequired,
  style: PropTypes.object
};
EditCommandCell.defaultProps = {
  style: undefined
};

var TableEditColumn$1 = function TableEditColumn$$1(_ref) {
  var cellTemplate = _ref.cellTemplate,
      headingCellTemplate = _ref.headingCellTemplate,
      commandTemplate = _ref.commandTemplate,
      restProps = objectWithoutProperties(_ref, ['cellTemplate', 'headingCellTemplate', 'commandTemplate']);
  return React.createElement(_devexpress_dxReactGrid.TableEditColumn, _extends({}, restProps, {
    cellTemplate: _devexpress_dxReactCore.combineTemplates(cellTemplate, EditCommandCell),
    headingCellTemplate: _devexpress_dxReactCore.combineTemplates(headingCellTemplate, EditCommandHeadingCell),
    commandTemplate: _devexpress_dxReactCore.combineTemplates(commandTemplate, CommandButton)
  }));
};
TableEditColumn$1.propTypes = {
  cellTemplate: PropTypes.func,
  headingCellTemplate: PropTypes.func,
  commandTemplate: PropTypes.func
};
TableEditColumn$1.defaultProps = {
  cellTemplate: undefined,
  headingCellTemplate: undefined,
  commandTemplate: undefined
};

exports.PagingPanel = PagingPanel$1;
exports.GroupingPanel = GroupingPanel$1;
exports.TableRowDetail = TableRowDetail$1;
exports.TableGroupRow = TableGroupRow$1;
exports.TableSelection = TableSelection$1;
exports.TableView = TableView$1;
exports.VirtualTableView = VirtualTableView;
exports.TableFilterRow = TableFilterRow$1;
exports.TableHeaderRow = TableHeaderRow$1;
exports.TableEditRow = TableEditRow$1;
exports.TableEditColumn = TableEditColumn$1;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=dx-react-grid-bootstrap3.umd.js.map
